---
### pvc for app uswgi
apiVersion: v1
kind: PersistentVolumeClaim
metadata:
  name: pvc-demo
  namespace: __namespace__
  labels:
    app: crm-dev
spec:
  accessModes:
    - ReadWriteOnce
  resources:
    requests:
      storage: 1Gi
--- 
#uwsgi+nginx container
apiVersion: apps/v1
kind: Deployment
metadata:
  name: uwsgi
  namespace: __namespace__
  labels:
    app: uwsgi
###
spec:
  replicas: __REPLICAS__
  selector:
    matchLabels:
      app: uwsgi
  template:
    metadata:
      labels:
        app: uwsgi
    spec:
      terminationGracePeriodSeconds: 10
      containers:        
      - name: uwsgi
        image: atalabirchuk/crm-__APP__:__TAG__
        command: ['/bin/sh', '-c', 'python manage.py migrate && python manage.py collectstatic --noinput && gunicorn crm.wsgi:application -b 0.0.0.0:8000 --timeout 120 --log-level=DEBUG --workers 3']        
        imagePullPolicy: Always
        env:
          - name: MY_POD_IP
            valueFrom:
              fieldRef:
                fieldPath: status.podIP
          - name: HOSTNAME
            valueFrom:
              fieldRef:
                fieldPath: metadata.name
          - name: NAMESPACE
            valueFrom:
              fieldRef:
                fieldPath: metadata.namespace
          - name: PS1
            value: "$$(whoami)@$$(hostname):$$(pwd) $$"
          - name: DJANGO_SETTINGS_MODULE
            value: "crm.settings.prod"
          - name: DB_USER
            valueFrom:
                secretKeyRef:
                  name: postgres-password
                  key: DB_USER          
          - name: DB_NAME
            value: "crm" 
          - name: DB_PASSWORD
            valueFrom:
                secretKeyRef:
                  name: postgres-password
                  key: DB_PASSWORD          
          - name: SENDGRID_API_KEY
            valueFrom:
                secretKeyRef:
                  name: sendgrid-api-key
                  key: SENDGRID_API_KEY  
          - name: DB_HOST
            value: "postgres"
          - name: DB_PORT
            value: "5432"
          - name: PYTHONPATH
            value: "/app/crm"
        volumeMounts:
          - name: volume-secret
            mountPath: "/volume-secret"
            readOnly: true    
          - name: sendgrid-api-key
            mountPath: "/sendgrid-api-key"
            readOnly: true                           

      - name: nginx-uwsgi
        image: nginx:stable
        ports:
          - name: uwsgi-80
            containerPort: 80
          - name: uwsgi-443
            containerPort: 443
        livenessProbe:
          httpGet:
            path: /basic_status
            port: 80
          periodSeconds: 10
          timeoutSeconds: 1
        readinessProbe:
          httpGet:
            path: /basic_status
            port: 80
          periodSeconds: 10
          timeoutSeconds: 1          
        volumeMounts:
        - mountPath: /etc/nginx/conf.d/nginx.conf # mount nginx-conf volumn to /etc/nginx
          readOnly: true
          name: nginx-uwsgi
          subPath: nginx.conf
        - mountPath: /etc/nginx/conf.d/default.conf # mount nginx-conf volumn to /etc/nginx
          readOnly: true
          name: nginx-uwsgi
          subPath: default.conf

        - name: static-cont
          mountPath: /robocraft/files/static

      - name: nginx-exporter
        image: fish/nginx-exporter
        args:
          - -nginx.scrape_uri=http://127.0.0.1/basic_status
        ports:
          - name: nginx-exporter
            containerPort: 9113
        livenessProbe:
          httpGet:
            path: /metrics
            port: 9113
          initialDelaySeconds: 20
          periodSeconds: 10
        readinessProbe:
          httpGet:
            path: /metrics
            port: 9113
          initialDelaySeconds: 20
          periodSeconds: 10


      initContainers:
      - name: init-uwsgi-static
        image: atalabirchuk/crm-__APP__:__TAG__
        command: ['/bin/sh', '-c', 'python manage.py collectstatic --noinput; apt install -y rsync; rsync --delete -azvh /app/crm/files/static/ /web1/']
        volumeMounts:
        - name: static-cont
          mountPath: /web1

      volumes:
      # - name: web-data
      #   persistentVolumeClaim:
      #     claimName: pvc-demo
      - name: static-cont
        emptyDir: {}
      - name: nginx-uwsgi
        configMap:
          name: nginx-uwsgi
          items:
            - key: nginx.conf
              path: nginx.conf
            - key: default.conf
              path: default.conf
      - name: volume-secret
        secret:
          secretName: postgres-password
      - name: sendgrid-api-key
        secret:
          secretName: sendgrid-api-key            
--- 
#service
apiVersion: v1
kind: Service
metadata:
  name: uwsgi
  labels:
    app: uwsgi
  namespace: __namespace__
spec:
  clusterIP: None
  ports:
   - name: uwsgi-80
     protocol: TCP
     port: 80
     targetPort: 80
   - name: uwsgi-443
     protocol: TCP
     port: 443
     targetPort: 443
   - name: nginx-exporter
     protocol: TCP
     port: 9113
     targetPort: 9113     
  selector:
   app: uwsgi
--- 


# ingress rule
apiVersion: extensions/v1beta1
kind: Ingress
metadata:
  name: dev
  namespace: __namespace__
  #namespace: canary
  labels:
    app: dev
  annotations:
    #nginx.ingress.kubernetes.io/rewrite-target: /
    cert-manager.io/acme-challenge-type: http01
    cert-manager.io/cluster-issuer: "letsencrypt-production"    
    ingress.kubernetes.io/ssl-redirect: "true"
    nginx.ingress.kubernetes.io/ssl-redirect: "true"    
    kubernetes.io/tls-acme: "true"
    kubernetes.io/ingress.class: nginx
    ingress.kubernetes.io/proxy-body-size: 100m
    nginx.ingress.kubernetes.io/proxy-body-size: 100m
    ingress.kubernetes.io/enable-cors: "true"
    ingress.kubernetes.io/cors-allow-methods: "GET, POST, OPTIONS, PUT, PATCH, DELETE"
    ingress.kubernetes.io/cors-allow-headers: "authorization,DNT,x-access-token,X-CustomHeader,Keep-Alive,User-Agent,X-Requested-With,If-Modified-Since,Cache-Control,Content-Type,x-csrftoken,Authorization,token,jwt-token"
    ingress.kubernetes.io/cors-allow-credentials: "true"
    ingress.kubernetes.io/rewrite-target: /

spec:
  rules:
  - host: robocraftlab.ru
    http:
      paths:
      - backend:
          serviceName: uwsgi
          servicePort: 80
        path: /
  tls:
  - hosts:
    - robocraftlab.ru
    secretName: robocraft-tls

---
apiVersion: monitoring.coreos.com/v1
kind: ServiceMonitor
metadata:
  name: nginx
  namespace: __namespace__
  labels:
    team: frontend
spec:
  selector:
    matchLabels:
      app: uwsgi
#      namespace: __namespace__
  endpoints:
  - port: nginx-exporter